package SlackBuild::Archive::Extractor;
use SlackBuild::Archive::Extractor::HTTP;
use SlackBuild::Archive::Extractor::Tar;
use Carp;

sub new {
    croak "bad number of arguments" unless @_ == 4;
    my ($class, $dn, $file, $destdir) = @_;
    if ($dn->isa('SlackBuild::Download')) {
	if ($dn->is_html) {
	    return new SlackBuild::Archive::Extractor::HTTP($dn->archive,
							    $file, $destdir);
	} else {
	    return new SlackBuild::Archive::Extractor::Tar($dn->archive,
							    $file, $destdir);
	}
    }
    return bless { _archive => $dn,
		   _tempfile => $file,
		   _destdir => $destdir }, $class;
}

sub logger {
    my $self = shift;
    $self->{_logger} //= Log::Log4perl::get_logger(ref($self))
}

sub archive  { shift->{_archive} }
sub destdir  { shift->{_destdir} }
sub tempfile { shift->{_tempfile} }
sub rewind { seek shift->tempfile, 0, 0 }

sub extract {
    my $self = shift;
    $self->logger->error('unrecognized download format');
    return new SlackBuild::Download($self)
}

1;
